precision highp float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureMask;
uniform sampler2D fTextureWhiteOrg;
uniform sampler2D fTextureShanfeng;

uniform float useShanfeng;//是否使用 白色中间层的FBO 2标识重置

uniform vec4 selectMaskColor;//点击位的mask颜色
uniform vec4 gStartColor;//渐变开始颜色
uniform vec4 gEndColor;//渐变开结束颜色

uniform float radius;
uniform vec2 clickPoint;
uniform float drawProgress;

vec4 mixcolor(vec4 bottom, vec4 top) {
    return vec4(
    top.r + bottom.r * (1.0 - top.a),
    top.g + bottom.g * (1.0 - top.a),
    top.b + bottom.b * (1.0 - top.a),
    1.0);
}


bool isEques(const vec4 colorOne, const vec4 colorTwo) {
    vec2 colorDist = abs(vec2(colorOne.r, colorOne.g) - vec2(colorTwo.r, colorTwo.g));
    return all(lessThan(colorDist, vec2(dx)));
}

float getOriginContrast(vec4 originColor){
    vec3 rgb=vec3(originColor.r, originColor.g, originColor.b);
    float contrast = (length(max(rgb, vec3(0))) + length(min(rgb, vec3(1)))) / length(vec3(1));
    return contrast;
}

vec4 blendMultiply(vec4 base, vec4 blend) {
    return base*blend;
}


vec4 jianbian() {
    vec4 originColor = texture2D(fTextureWhiteOrg, aCoordinate);
    vec4 start = blendMultiply(gStartColor,originColor);
    vec4 end = blendMultiply(gEndColor,originColor);
    return mix(start, end, 2.0 * distance(aCoordinate, vec2(0.5, 0.5)));
}

vec4 shangfeng(vec4 rgbaUse) {
    highp float dw = 1.0 / 8.0;
    highp float dh = 1.0 / 8.0;
    highp float dx = (aCoordinate.x - floor(aCoordinate.x / dw) * dw) / dw;
    highp float dy = (aCoordinate.y - floor(aCoordinate.y / dh) * dh) / dh;
    vec2 dMosaicCoor = vec2(dx, dy);
    vec4 rgbaShanfeng = texture2D(fTextureShanfeng, dMosaicCoor);
    return mixcolor(rgbaUse, rgbaShanfeng);
}

bool isContain(vec2 position, vec2 center, float radius) {
    float dist = distance(position, center);
    return dist<radius;
}

void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    vec4 resultColor = jianbian();
    vec4 shangfengColor = shangfeng(resultColor);
    resultColor =mix(resultColor,shangfengColor,useShanfeng);
    resultColor = mix(vec4(1.0), resultColor, gStartColor.a);//如果是undo的最后一个 传递的颜色是透明色，取白色
    float contain = isContain(aCoordinate, clickPoint, radius) ? 1.0: 0.0;
    bool isSmoothDraw = isEques(vec4(0.0), vec4(drawProgress));
    resultColor = isSmoothDraw ? (resultColor*contain) : resultColor;
    gl_FragColor = isEques(rgba, selectMaskColor) ? resultColor : vec4(0.0);
}


