//#version 120 //attribute
precision highp float;
const float dx = 0.003922;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureMask;
uniform sampler2D fTextureShanfeng;

uniform vec4 selectMaskColor;//点击位的mask颜色


bool isEques(const vec4 colorOne, const vec4 colorTwo) {
    vec2 colorDist = abs(vec2(colorOne.r, colorOne.g) - vec2(colorTwo.r, colorTwo.g));
    return all(lessThan(colorDist, vec2(DX)));
}

void main() {
    vec4 rgba = texture2D(fTextureMask, aCoordinate);
    vec4 rgbaShanfeng = texture2D(fTextureShanfeng, aCoordinate);
    gl_FragColor =isEques(rgba, selectMaskColor)?rgbaShanfeng:vec4(0.0);
}


